diff --git a/doc/filters.texi b/doc/filters.texi
index 9611a41..2e7caf3 100644
--- a/doc/filters.texi
+++ b/doc/filters.texi
@@ -2248,6 +2248,22 @@ Set temperature degree in Celsius. This is the temperature of the environment.
 Default is 20.
 @end table
 
+@section crossfeed
+Apply headphone crossfeed filter.
+
+The filter accepts the following options:
+
+@table @option
+@item strength
+Set strength of crossfeed. Default is 0.1. Allowed range is from 0 to 1.
+
+@item level_in
+Set input gain. Default is 0.9.
+
+@item level_out
+Set output gain. Default is 1.
+@end table
+
 @section crystalizer
 Simple algorithm to expand audio dynamic range.
 
diff --git a/libavfilter/Makefile b/libavfilter/Makefile
index f177fdb..434a989 100644
--- a/libavfilter/Makefile
+++ b/libavfilter/Makefile
@@ -81,6 +81,7 @@ OBJS-$(CONFIG_CHANNELSPLIT_FILTER)           += af_channelsplit.o
 OBJS-$(CONFIG_CHORUS_FILTER)                 += af_chorus.o generate_wave_table.o
 OBJS-$(CONFIG_COMPAND_FILTER)                += af_compand.o
 OBJS-$(CONFIG_COMPENSATIONDELAY_FILTER)      += af_compensationdelay.o
+OBJS-$(CONFIG_CROSSFEED_FILTER)              += af_crossfeed.o
 OBJS-$(CONFIG_CRYSTALIZER_FILTER)            += af_crystalizer.o
 OBJS-$(CONFIG_DCSHIFT_FILTER)                += af_dcshift.o
 OBJS-$(CONFIG_DYNAUDNORM_FILTER)             += af_dynaudnorm.o
diff --git a/libavfilter/af_crossfeed.c b/libavfilter/af_crossfeed.c
new file mode 100644
index 0000000..8a9ecad
--- /dev/null
+++ b/libavfilter/af_crossfeed.c
@@ -0,0 +1,161 @@
+/*
+ * This file is part of FFmpeg.
+ *
+ * FFmpeg is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Lesser General Public
+ * License as published by the Free Software Foundation; either
+ * version 2.1 of the License, or (at your option) any later version.
+ *
+ * FFmpeg is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with FFmpeg; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
+ */
+
+#include "libavutil/channel_layout.h"
+#include "libavutil/opt.h"
+#include "avfilter.h"
+#include "audio.h"
+#include "formats.h"
+
+typedef struct CrossfeedContext {
+    const AVClass *class;
+
+    double strength;
+    double level_in;
+    double level_out;
+
+    double a0, a1, a2;
+    double b0, b1, b2;
+
+    double i1, i2;
+    double o1, o2;
+} CrossfeedContext;
+
+static int query_formats(AVFilterContext *ctx)
+{
+    AVFilterFormats *formats = NULL;
+    AVFilterChannelLayouts *layout = NULL;
+    int ret;
+
+    if ((ret = ff_add_format                 (&formats, AV_SAMPLE_FMT_DBL  )) < 0 ||
+        (ret = ff_set_common_formats         (ctx     , formats            )) < 0 ||
+        (ret = ff_add_channel_layout         (&layout , AV_CH_LAYOUT_STEREO)) < 0 ||
+        (ret = ff_set_common_channel_layouts (ctx     , layout             )) < 0 ||
+        (ret = ff_set_common_samplerates     (ctx     , ff_all_samplerates())) < 0)
+        return ret;
+
+    return 0;
+}
+
+static int config_input(AVFilterLink *inlink)
+{
+    AVFilterContext *ctx = inlink->dst;
+    CrossfeedContext *s = ctx->priv;
+    double w0 = 2 * M_PI * s->strength * 1000 / inlink->sample_rate;
+    double alpha;
+
+    alpha = sin(w0) / 2 * sqrt(2 * (1 / 0.707 - 1) + 2);
+
+    s->a0 =   1 + alpha;
+    s->a1 =  -2 * cos(w0);
+    s->a2 =   1 - alpha;
+    s->b0 =  (1 + cos(w0)) / 2;
+    s->b1 = -(1 + cos(w0));
+    s->b2 =  (1 + cos(w0)) / 2;
+
+    s->a1 /= s->a0;
+    s->a2 /= s->a0;
+    s->b0 /= s->a0;
+    s->b1 /= s->a0;
+    s->b2 /= s->a0;
+
+    return 0;
+}
+
+static int filter_frame(AVFilterLink *inlink, AVFrame *in)
+{
+    AVFilterContext *ctx = inlink->dst;
+    AVFilterLink *outlink = ctx->outputs[0];
+    CrossfeedContext *s = ctx->priv;
+    const double *src = (const double *)in->data[0];
+    const double level_in = s->level_in;
+    const double level_out = s->level_out;
+    AVFrame *out;
+    double *dst;
+    int n;
+
+    if (av_frame_is_writable(in)) {
+        out = in;
+    } else {
+        out = ff_get_audio_buffer(inlink, in->nb_samples);
+        if (!out) {
+            av_frame_free(&in);
+            return AVERROR(ENOMEM);
+        }
+        av_frame_copy_props(out, in);
+    }
+    dst = (double *)out->data[0];
+
+    for (n = 0; n < out->nb_samples; n++, src += 2, dst += 2) {
+        double mid = (src[0] + src[1]) * level_in * .5;
+        double side = (src[0] - src[1]) * level_in * .5;
+
+        double oside = side * s->b0 + s->i1 * s->b1 + s->i2 * s->b2 - s->o1 * s->a1 - s->o2 * s->a2;
+        s->i2 = s->i1;
+        s->i1 = side;
+        s->o2 = s->o1;
+        s->o1 = oside;
+
+        dst[0] = (mid + oside) * level_out;
+        dst[1] = (mid - oside) * level_out;
+    }
+
+    if (out != in)
+        av_frame_free(&in);
+    return ff_filter_frame(outlink, out);
+}
+
+#define OFFSET(x) offsetof(CrossfeedContext, x)
+#define FLAGS AV_OPT_FLAG_AUDIO_PARAM|AV_OPT_FLAG_FILTERING_PARAM
+
+static const AVOption crossfeed_options[] = {
+    { "strength",  "set crossfeed strength", OFFSET(strength),  AV_OPT_TYPE_DOUBLE, {.dbl=.1}, 0, 1, FLAGS },
+    { "level_in",  "set level in",           OFFSET(level_in),  AV_OPT_TYPE_DOUBLE, {.dbl=.9}, 0, 1, FLAGS },
+    { "level_out", "set level out",          OFFSET(level_out), AV_OPT_TYPE_DOUBLE, {.dbl=1.}, 0, 1, FLAGS },
+    { NULL }
+};
+
+AVFILTER_DEFINE_CLASS(crossfeed);
+
+static const AVFilterPad inputs[] = {
+    {
+        .name         = "default",
+        .type         = AVMEDIA_TYPE_AUDIO,
+        .filter_frame = filter_frame,
+        .config_props = config_input,
+    },
+    { NULL }
+};
+
+static const AVFilterPad outputs[] = {
+    {
+        .name = "default",
+        .type = AVMEDIA_TYPE_AUDIO,
+    },
+    { NULL }
+};
+
+AVFilter ff_af_crossfeed = {
+    .name           = "crossfeed",
+    .description    = NULL_IF_CONFIG_SMALL("Apply headphone crossfeed filter."),
+    .query_formats  = query_formats,
+    .priv_size      = sizeof(CrossfeedContext),
+    .priv_class     = &crossfeed_class,
+    .inputs         = inputs,
+    .outputs        = outputs,
+};
diff --git a/libavfilter/allfilters.c b/libavfilter/allfilters.c
index a8939b9..2bcfce7 100644
--- a/libavfilter/allfilters.c
+++ b/libavfilter/allfilters.c
@@ -94,6 +94,7 @@ static void register_all(void)
     REGISTER_FILTER(CHORUS,         chorus,         af);
     REGISTER_FILTER(COMPAND,        compand,        af);
     REGISTER_FILTER(COMPENSATIONDELAY, compensationdelay, af);
+    REGISTER_FILTER(CROSSFEED,      crossfeed,      af);
     REGISTER_FILTER(CRYSTALIZER,    crystalizer,    af);
     REGISTER_FILTER(DCSHIFT,        dcshift,        af);
     REGISTER_FILTER(DYNAUDNORM,     dynaudnorm,     af);